#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <Windows.h>

struct Range
{
	int from;
	int to;
};

static long long sum;
HANDLE mutex;

DWORD _stdcall sumThread(void* params)
{
	Range* range = (Range*)params;

	for (int i = range->from; i <= range->to; i++)
	{
		WaitForSingleObject(mutex, INFINITE);
		sum += i;
		ReleaseMutex(mutex);
	}

	return 0;
}

void sumFunction(int from, int to)
{
	for (int i = from; i <= to; i++)
	{
		sum += i;
	}
}

int main()
{
	sum = 0;

	HANDLE threadHandles[4];
	DWORD threadIds[4];
	Range ranges[4] = { { 1, 100000 }, { 100001, 200000 }, { 200001, 300000 }, { 300001, 400000 } };

	mutex = CreateMutex(NULL, FALSE, NULL);

	for (size_t i = 0; i < 4; i++)
	{
		threadHandles[i] = CreateThread(NULL, 0, sumThread, &ranges[i], 0, &threadIds[i]);
	}

	WaitForMultipleObjects(4, threadHandles, TRUE, INFINITE);

	for (size_t i = 0; i < 4; i++)
	{
		CloseHandle(threadHandles[i]);
	}

	CloseHandle(mutex);

	printf("Calculated sum using threads is: %lld\n", sum);
	
	sum = 0;

	sumFunction(1, 400000);

	printf("Calculated sum without threads is: %lld\n", sum);

	return 0;
}

